<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/24/2005 *
 * ===================                          Last change: 05/12/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-edit_sponsor.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Edit sponsor account                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenaccount aendern                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
}

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if ((isGetRequestElementSet('id')) && (isGetRequestElementSet('mode'))) {
	// Check for selected sponsor
	$result_main = SQL_QUERY_ESC("SELECT
	`company`, `position`, `gender`, `surname`, `family`,
	`street_nr1`, `street_nr2`, `zip`, `city`, `country`,
	`phone`, `fax`, `cell`, `email`, `url`, `tax_ident`,
	`receive_warnings`, `warning_interval`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_data`
WHERE
	`id`='%s'
LIMIT 1",
		array(bigintval(getRequestElement('id'))), __FILE__, __LINE__);
	if (SQL_NUMROWS($result_main) == 1) {
		// Load sponsor details
		$content = SQL_FETCHARRAY($result_main);

		// Prepare all data for the template
		//  Sponsor's id
		$content['id'] = bigintval(getRequestElement('id'));

		// Init gender
		foreach (array('m', 'f', 'c') as $gender) {
			$content['gender_' . $gender] = '';
		} // END - foreach

		// Check for gender selection
		$content['gender_' . strtolower($content['gender'])] = ' selected="selected"';

		//  Warning because low points
		$content['receive_warnings'] = addSelectionBox('yn', $content['receive_warnings'], 'receive_warning');
		$content['interval']         = createTimeSelections($content['warning_interval'], 'warning_interval', 'MWDh');

		// Init variables here
		$TPL = sprintf("admin_edit_sponsor_%s", getRequestElement('mode'));
		initSqls();

		// Sponsor was found
		if ((isFormSent()) || (isPostRequestElementSet('edit'))) {
			// Perform action on mode
			switch (getRequestElement('mode')) {
				case 'add_points': // Add points
					if (bigintval(postRequestElement('points')) > 0) {
						// Replace german decimal comma with computer's decimal dot
						$points = bigintval(convertCommaToDot(postRequestElement('points')));

						// Add points to account
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_sponsor_data` SET `points_amount`=`points_amount`+%s WHERE `id`='%s' LIMIT 1",
							array($points, bigintval(getRequestElement('id'))), __FILE__, __LINE__);

						// Remember points /reason for the template
						$content['points'] = translateComma($points);
						$content['reason'] = secureString(postRequestElement('reason'));

						// Send email
						$message = loadEmailTemplate('sponsor_add_points', $content);
						sendEmail($content['email'], getMessage('ADMIN_SPONSOR_ADD_POINTS_SUBJ'), $message);
						$message = getMessage('ADMIN_SPONSOR_POINTS_ADDED');
					} else {
						// No points entered to add!
						$message = getMessage('ADMIN_SPONSPOR_NO_POINTS_TO_ADD');
					}
					break;

				case 'sub_points': // Subtract points
					if (bigintval(postRequestElement('points')) > 0) {
						// Replace german decimal comma with computer's decimal dot
						$points = bigintval(convertCommaToDot(postRequestElement('points')));

						// Add points to account
						SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_sponsor_data` SET `points_used`=`points_used`+%s WHERE `id`='%s' LIMIT 1",
							array($points, bigintval(getRequestElement('id'))), __FILE__, __LINE__);

						// Remember points /reason for the template
						$content['points'] = translateComma($points);
						$content['reason'] = secureString(postRequestElement('reason'));

						// Send email
						$message = loadEmailTemplate('sponsor_sub_points', $content);
						sendEmail($content['email'], getMessage('ADMIN_SPONSOR_SUB_POINTS_SUBJ'), $message);
						$message = getMessage('ADMIN_SPONSOR_POINTS_SUBTRACTED');
					} else {
						// No points entered to add!
						$message = getMessage('ADMIN_SPONSPOR_NO_POINTS_TO_SUBTRACT');
					}
					break;

				case 'edit': // Edit sponsor account
					$PASS = true;
					if ((postRequestElement('pass1') != postRequestElement('pass2')) || ((!isPostRequestElementSet('pass1')) && (!isPostRequestElementSet('pass1')))) {
						// Remove passwords
						unsetPostRequestElement('pass1');
						unsetPostRequestElement('pass2');
						$PASS = false;
					} // END - if

					// Convert time selection
					$DATA = array(); $id = 'warning_interval_ye'; $skip = false;
					convertSelectionsToTimestamp(postRequestArray(), $DATA, $id, $skip);

					// Save the sponsor
					handlSponsorRequest(postRequestArray());

					// Convert some data for the email template
					postRequestElement('gender'          , translateGender(postRequestElement('gender')));
					postRequestElement('warning_interval', createFancyTime(postRequestElement('warning_interval')));

					if ($PASS === false) setRequestPostElement('pass1', getMessage('SPONSOR_PASS_UNCHANGED'));

					// Load email template and send the mail away
					$message = loadEmailTemplate('admin_sponsor_edit', postRequestArray(), false);
					sendEmail(postRequestElement('email'), getMessage('ADMIN_SPONSOR_EDIT_SUBJECT'), $message);
					break;

				default: // Unknown mode
					logDebugMessage(__FILE__, __LINE__, sprintf("Unknown mode %s detected.", getRequestElement('mode')));
					$message = sprintf(getMessage('ADMIN_SPONSOR_INVALID_MODE'), getRequestElement('mode'));
					break;
			}

			if (!empty($message)) {
				// Output message
				loadTemplate('admin_settings_saved', false, $message);
			} // END - if
		} elseif (isFileReadable(sprintf("%stemplates/%s/html/admin/%s.tpl", getConfig('PATH'), getLanguage(), $TPL))) {
			// Create mailto link
			$content['contact'] = "<a href=\"" . generateEmailLink($content['email'], 'sponsor_data') . "\">" . $content['surname'] . " " . $content['family'] . "</a>";

			// Load mode template
			loadTemplate($TPL);
		} else {
			// Template not found!
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SPONSOR_MODUS_TPL_404'), getRequestElement('mode')));
		}
	} else {
		// Sponsor not found!
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_SPONSOR_404'), bigintval(getRequestElement('id'))));
	}

	// Free result
	SQL_FREERESULT($result_main);
} else {
	// Not called by what-list_sponsor.php
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_CALL_NOT_DIRECTLY'));
}

// [EOF]
?>
